#
# spec file for package openstack-glance
#
# Copyright (c) 2019 SUSE LINUX GmbH, Nuernberg, Germany.
#
# All modifications and additions to the file contributed by third parties
# remain the property of their copyright owners, unless otherwise agreed
# upon. The license for this file, and modifications and additions to the
# file, is the same license as for the pristine package itself (unless the
# license for the pristine package is not an Open Source License, in which
# case the license is the MIT License). An "Open Source License" is a
# license that conforms to the Open Source Definition (Version 1.9)
# published by the Open Source Initiative.

# Please submit bugfixes or comments via https://bugs.opensuse.org/
#


%global with_doc 1
%if 0%{?rhel} || 0%{?fedora}
%global rdo 1
%endif
Name:           openstack-glance
Version:        17.0.1~dev18
Release:        1.6
Summary:        OpenStack Image Service (Glance)
License:        Apache-2.0
Group:          Applications/System
URL:            https://launchpad.net/glance
Source0:        glance-stable-rocky.tar.gz
Source1:        openstack-glance.logrotate
Source2:        openstack-glance.conf
Source3:        openstack-glance-api.service
Source5:        openstack-glance-registry.service
Source6:        openstack-glance.defaultconf
Source7:        openstack-glance.README.config
BuildRequires:  openstack-macros
BuildRequires:  python3-Paste
BuildRequires:  python3-PasteDeploy
BuildRequires:  python3-Routes
BuildRequires:  python3-WSME
BuildRequires:  python3-WebOb
BuildRequires:  python3-cursive
BuildRequires:  python3-ddt
BuildRequires:  python3-debtcollector
BuildRequires:  python3-defusedxml
BuildRequires:  python3-eventlet
BuildRequires:  python3-futurist
BuildRequires:  python3-glance_store
BuildRequires:  python3-httplib2
BuildRequires:  python3-keystoneclient
BuildRequires:  python3-keystonemiddleware
BuildRequires:  python3-oslo.concurrency
BuildRequires:  python3-oslo.config
BuildRequires:  python3-oslo.context
BuildRequires:  python3-oslo.db
BuildRequires:  python3-oslo.log
BuildRequires:  python3-oslo.messaging
BuildRequires:  python3-oslo.middleware
BuildRequires:  python3-oslo.policy
BuildRequires:  python3-oslo.utils
BuildRequires:  python3-oslotest
BuildRequires:  python3-osprofiler
BuildRequires:  python3-pyOpenSSL
BuildRequires:  python3-sqlparse
BuildRequires:  python3-stestr
BuildRequires:  python3-stevedore
BuildRequires:  python3-taskflow
BuildRequires:  python3-xattr
Requires:       logrotate
Requires:       python3-glance = %{version}-%{release}
BuildArch:      noarch
%if 0%{?suse_version}
BuildRequires:  systemd-rpm-macros
%{?systemd_requires}
%else
BuildRequires:  systemd
Requires(post): systemd
Requires(postun): systemd
Requires(preun): systemd
%endif
%if 0%{?suse_version}
Requires(pre):  pwdutils
%endif
%if 0%{?rdo}
Requires(pre):  shadow-utils
%endif

%description
The Glance project provides a service where users can upload and discover
data assets that are meant to be used with other services. This currently
includes images and metadata definitions.
Glance image services include discovering, registering, and retrieving
virtual machine images. Glance has a RESTful API that allows querying of
VM image metadata as well as retrieval of the actual image.
VM images made available through Glance can be stored in a variety of
locations from simple filesystems to object-storage systems like the
OpenStack Swift project.

%package -n     python3-glance
Summary:        OpenStack Image Service (Glance) - Python module
Group:          Applications/System
Requires:       python3-Paste
Requires:       python3-PasteDeploy
Requires:       python3-PrettyTable
Requires:       python3-Routes
Requires:       python3-SQLAlchemy
Requires:       python3-WSME
Requires:       python3-WebOb
Requires:       python3-alembic
Requires:       python3-cryptography
Requires:       python3-cursive
Requires:       python3-debtcollector
Requires:       python3-defusedxml
Requires:       python3-eventlet
Requires:       python3-futurist
Requires:       python3-glance_store
Requires:       python3-httplib2
Requires:       python3-iso8601
Requires:       python3-jsonschema
Requires:       python3-keystoneauth1
Requires:       python3-keystoneclient
Requires:       python3-keystonemiddleware
Requires:       python3-monotonic
Requires:       python3-oslo.concurrency
Requires:       python3-oslo.config
Requires:       python3-oslo.context
Requires:       python3-oslo.db
Requires:       python3-oslo.i18n
Requires:       python3-oslo.log
Requires:       python3-oslo.messaging
Requires:       python3-oslo.middleware
Requires:       python3-oslo.policy
Requires:       python3-oslo.utils
Requires:       python3-osprofiler
Requires:       python3-pbr
Requires:       python3-pyOpenSSL
Requires:       python3-retrying
Requires:       python3-six
Requires:       python3-sqlalchemy-migrate
Requires:       python3-sqlparse
Requires:       python3-stevedore
Requires:       python3-taskflow

%description -n python3-glance
The Glance project provides a service where users can upload and discover
data assets that are meant to be used with other services. This currently
includes images and metadata definitions.
Glance image services include discovering, registering, and retrieving
virtual machine images. Glance has a RESTful API that allows querying of
VM image metadata as well as retrieval of the actual image.
VM images made available through Glance can be stored in a variety of
locations from simple filesystems to object-storage systems like the
OpenStack Swift project.

This package contains the Glance Python library.

%package -n python3-glance-tests
Summary:        Glance tests
Group:          Applications/System
Requires:       openstack-glance = %{version}-%{release}
Provides:       python-glance-tests = %{version}-%{release}

%description -n python3-glance-tests
The Glance project provides a service where users can upload and discover
data assets that are meant to be used with other services. This currently
includes images and metadata definitions.
Glance image services include discovering, registering, and retrieving
virtual machine images. Glance has a RESTful API that allows querying of
VM image metadata as well as retrieval of the actual image.
VM images made available through Glance can be stored in a variety of
locations from simple filesystems to object-storage systems like the
OpenStack Swift project.

This package contains the Glance test files.

%if 0%{?with_doc}
%package doc
Summary:        Documentation for OpenStack Image Service
Group:          Documentation
BuildRequires:  python-Sphinx
BuildRequires:  python-WSME
BuildRequires:  python-cursive
BuildRequires:  python-glance_store
BuildRequires:  python-httplib2
BuildRequires:  python-openstackdocstheme
BuildRequires:  python-oslo.concurrency
BuildRequires:  python-oslo.config
BuildRequires:  python-oslo.context
BuildRequires:  python-oslo.db
BuildRequires:  python-oslo.log
BuildRequires:  python-oslo.messaging
BuildRequires:  python2-oslo.middleware
BuildRequires:  python-oslo.policy
BuildRequires:  python-oslo.utils
BuildRequires:  python-osprofiler
BuildRequires:  python-sphinxcontrib-apidoc
BuildRequires:  python-stevedore
BuildRequires:  python-taskflow
BuildRequires:  python-xattr

%description doc
The Glance project provides a service where users can upload and discover
data assets that are meant to be used with other services. This currently
includes images and metadata definitions.
Glance image services include discovering, registering, and retrieving
virtual machine images. Glance has a RESTful API that allows querying of
VM image metadata as well as retrieval of the actual image.
VM images made available through Glance can be stored in a variety of
locations from simple filesystems to object-storage systems like the
OpenStack Swift project.

This package contains the documentation.
%endif

%package api
Summary:        OpenStack Image service (Glance) - API
Group:          Development/Languages/Python
Requires:       %{name} = %{version}-%{release}

%description api
The Glance project provides a service where users can upload and discover
data assets that are meant to be used with other services. This currently
includes images and metadata definitions.
Glance image services include discovering, registering, and retrieving
virtual machine images. Glance has a RESTful API that allows querying of
VM image metadata as well as retrieval of the actual image.
VM images made available through Glance can be stored in a variety of
locations from simple filesystems to object-storage systems like the
OpenStack Swift project.

This package contains the %{name} API server.

%package registry
Summary:        OpenStack Image service (Glance) - Registry
Group:          Development/Languages/Python
Requires:       %{name} = %{version}-%{release}

%description registry
The Glance project provides a service where users can upload and discover
data assets that are meant to be used with other services. This currently
includes images and metadata definitions.
Glance image services include discovering, registering, and retrieving
virtual machine images. Glance has a RESTful API that allows querying of
VM image metadata as well as retrieval of the actual image.
VM images made available through Glance can be stored in a variety of
locations from simple filesystems to object-storage systems like the
OpenStack Swift project.

This package contains the %{name} Registry server.

%prep
%autosetup -n glance-17.0.1.dev18
%py_req_cleanup

%build
%{py3_build}
# build documentation
%if 0%{?with_doc}
PBR_VERSION=17.0.1.dev18 sphinx-build -b html doc/source doc/build/html
rm -rf doc/build/html/.{doctrees,buildinfo}
%endif
# regenerate the sample config files
for service in api registry scrubber cache manage image-import; do
    PYTHONPATH=. oslo-config-generator --config-file etc/oslo-config-generator/glance-$service.conf
done

%install
%{py3_install}
# directories
install -d -m 755 %{buildroot}%{_sysconfdir}/glance
install -d -m 755 %{buildroot}%{_sysconfdir}/glance/glance.conf.d/
install -d -m 755 %{buildroot}%{_sysconfdir}/glance/glance-api.conf.d/
install -d -m 755 %{buildroot}%{_sysconfdir}/glance/glance-registry.conf.d/
install -d -m 755 %{buildroot}%{_localstatedir}/lib/glance
install -d -m 755 %{buildroot}%{_localstatedir}/lib/glance/images
install -d -m 750 %{buildroot}%{_localstatedir}/log/glance
install -d -m 750 %{buildroot}%{_localstatedir}/cache/glance
install -d -m 700 %{buildroot}%{_rundir}/glance
# tmpfile generator
install -D -m 644 %{SOURCE2} %{buildroot}/%{_tmpfilesdir}/glance.conf
# install sample configs
cp -pr etc/* %{buildroot}%{_sysconfdir}/glance
for service in api registry scrubber cache manage swift image-import; do
    mv %{buildroot}%{_sysconfdir}/glance/glance-$service.conf{.sample,}
done
install -p -D -m 640 %{SOURCE6} %{buildroot}%{_sysconfdir}/glance/README.config
rm -rf %{buildroot}%{_sysconfdir}/glance/oslo-config-generator
# default config
install -D -m 640 %{SOURCE6} %{buildroot}/%{_sysconfdir}/glance/glance.conf.d/010-glance.conf
# systemd
install -p -D -m 444 %{SOURCE3} %{buildroot}%{_unitdir}/openstack-glance-api.service
install -p -D -m 444 %{SOURCE5} %{buildroot}%{_unitdir}/openstack-glance-registry.service
# logrotate
install -p -D -m 644 %{SOURCE1} %{buildroot}%{_sysconfdir}/logrotate.d/openstack-glance
# move metadefs
mv %{buildroot}%{_prefix}%{_sysconfdir}/glance/metadefs/* %{buildroot}%{_sysconfdir}/glance/metadefs
# Remove duplicate files under /usr/etc
rm -rf %{buildroot}%{_prefix}%{_sysconfdir}/glance

%pre
%openstack_pre_user_group_create glance glance /sbin/nologin
exit 0

%check
%if 0%{?suse_version}
PYTHON=python3 OS_TEST_PATH=./glance/tests/unit PYTHONPATH=. stestr run
%endif
%if 0%{?rdo}
OS_TEST_PATH=./glance/tests/unit PYTHONPATH=. stestr-3 run
%endif

%post
%tmpfiles_create %{_tmpfilesdir}/glance.conf

%post api
%systemd_post %{name}-api.service

%preun api
%systemd_preun %{name}-api.service

%postun api
%systemd_postun_with_restart %{name}-api.service

%post registry
%systemd_post %{name}-registry.service

%preun registry
%systemd_preun %{name}-registry.service

%postun registry
%systemd_postun_with_restart %{name}-registry.service

%files
%license LICENSE
%_tmpfilesdir/glance.conf
%dir %attr(0750, root, glance) %{_sysconfdir}/glance
%dir %attr(0750, root, glance) %{_sysconfdir}/glance/glance.conf.d/
%dir %attr(0750, root, glance) %{_sysconfdir}/glance/glance-api.conf.d/
%dir %attr(0750, root, glance) %{_sysconfdir}/glance/glance-registry.conf.d/
%config(noreplace) %attr(0640, root, glance) %{_sysconfdir}/glance/glance.conf.d/010-glance.conf
%{_sysconfdir}/glance/README.config
%config(noreplace) %attr(0640, root, glance) %{_sysconfdir}/glance/rootwrap.conf
%config(noreplace) %attr(0640, root, glance) %{_sysconfdir}/glance/glance-api.conf
%config(noreplace) %attr(0640, root, glance) %{_sysconfdir}/glance/glance-cache.conf
%config(noreplace) %attr(0640, root, glance) %{_sysconfdir}/glance/glance-image-import.conf
%config(noreplace) %attr(0640, root, glance) %{_sysconfdir}/glance/glance-registry.conf
%config(noreplace) %attr(0640, root, glance) %{_sysconfdir}/glance/glance-scrubber.conf
%config(noreplace) %attr(0640, root, glance) %{_sysconfdir}/glance/glance-swift.conf
%config(noreplace) %attr(0640, root, glance) %{_sysconfdir}/glance/glance-manage.conf
%config %{_sysconfdir}/glance/glance-api-paste.ini
%config %{_sysconfdir}/glance/glance-registry-paste.ini
%config %{_sysconfdir}/glance/policy.json
%config %{_sysconfdir}/glance/property-protections-policies.conf.sample
%config %{_sysconfdir}/glance/property-protections-roles.conf.sample
%config %{_sysconfdir}/glance/ovf-metadata.json.sample
%config %{_sysconfdir}/glance/schema-image.json
%dir %config %{_sysconfdir}/glance/metadefs
%{_sysconfdir}/glance/metadefs/README
%config %{_sysconfdir}/glance/metadefs/*.json
%config(noreplace) %{_sysconfdir}/logrotate.d/%{name}
%dir %attr(0755, glance, glance) %{_localstatedir}/lib/glance
%dir %attr(0755, glance, glance) %{_localstatedir}/lib/glance/images
%dir %attr(0750, glance, glance) %{_localstatedir}/log/glance
%dir %attr(0750, glance, glance) %{_localstatedir}/cache/glance
%{_bindir}/glance-cache-cleaner
%{_bindir}/glance-cache-manage
%{_bindir}/glance-cache-prefetcher
%{_bindir}/glance-cache-pruner
%{_bindir}/glance-control
%{_bindir}/glance-manage
%{_bindir}/glance-replicator
%{_bindir}/glance-scrubber

%files -n python3-glance
%defattr(-,root,root,-)
%license LICENSE
%{python3_sitelib}/glance*
%exclude %{python3_sitelib}/glance/tests

%files -n python3-glance-tests
%license LICENSE
%{python3_sitelib}/glance/tests

%if 0%{?with_doc}
%files doc
%license LICENSE
%doc doc/build/html
%endif

%files api
%defattr(-,root,root,-)
%{_unitdir}/openstack-glance-api.service
%{_bindir}/glance-api
%{_bindir}/glance-wsgi-api

%files registry
%defattr(-,root,root,-)
%{_unitdir}/openstack-glance-registry.service
%{_bindir}/glance-registry

%changelog
